/* options.h contains all the compile time decisions as for what form of   *
 * the scoring algorithm to use.                                           *
 */

#ifndef __options_h__
#define __options_h__ 1

/***/
/* #define DEBUG_PRINTOUT */
/***/
#define SHOW_DISCLAIMER 
#define NOT_PROB

/** #define NoGenProline        **/   /** Make genbnk prob of proline 0 **/

#define TEST_VERSION       /** Puts in extra options that aren't available **/
			   /** in the program release.			   **/
/**/
#define SMALL_MEMORY  
/***/

#define AVG_WEIRD_PROBS
#define BONNIE_END_EFFECTS 
	                     /* Controls how handle windows that go beyond */
                             /* the end of the sequence.  **/

/* #define MinDist */   /*  The algorithm for computing residue propensities */
#define AvgDist         /*  in scscore.c is determined by which is #defined. */


#define LOGSCALE        /* If LOGSCALE then STOCK scores are given according */
                        /* to their scoring system. Otherwise, use           */
                        /* e^STOCK/28.                                       */

#define STOCKSTOCK       /*  Uses the stock programs singles probabilities */
	                 /*  as computed from their data sets, not ours.   */
			 /*  This allows us to compare with the actual runs*/
	                 /*  of stock's program.                           */
/*#define STOCKOUR*/     /*  Uses the singles probability to be the prob.  */
	                 /*  of the positives normalized by genbnk.  This  */
	                 /*  allows us to compare with stock's method on   */
	                 /*  different positive data sets.                 */


    
/*** For computing residue propensities in scscore.c.                  */
#ifdef MinDist
#define SCOREIDENTITY HUGE_VAL
#define SCOREACCUMULATE(GSC,SC) if ((GSC) > (SC)) (GSC) = (SC)
#endif
#ifdef AvgDist
#define SCOREIDENTITY 0
#define SCOREACCUMULATE(GSC,SC) (GSC) += (SC)/functnum
#endif

/*  For determining the singles probabilities when scoring STOCK method.  */
#ifdef STOCKOUR
#define RELATIVE(RESIDUE,REGISTER) (pprobs[RESIDUE][REGISTER] -gprobs[RESIDUE])
#endif
#ifdef STOCKSTOCK
#define RELATIVE(RESIDUE,REGISTER) (relative[RESIDUE][REGISTER])
#endif


#endif   /* __options_h__ */

