/* switches.h defines all the switches that the user can type in at the  */
/* command line to do various options with the program.                  */
/* SC2SEQ and SCSTOCK keep track of what algorithm the program is running.*/

#ifndef __switches_h__
#define __switches_h__ 1


#define SC2SEQ   1
#define SCSTOCK  2



/* Switches Definitions */
#define FUNCTNUM_SWITCH "-f"
#define POS_SWITCH "-pos" 
#define VER_SWITCH "-v"
#define PRN_SWITCH "-p"
#define TST_SWITCH0 "-1"
#define TST_SWITCH1 "-2"
#define VIEW_SWITCH "-g"
#define NOT_PROLINE_FREE_SWITCH "-P"
#define DEBUG_SWITCH "-d"  /* Used to print out coils in log file.  */
                           /* If the option is written a "-d + <int>"     */
                           /* then that means to only print out coils     */
                           /* from the .pos file, and to print residues   */
                           /* in the range [bound, bound+int] in capitals */
                           /* where bound comes from -p option            */
#define PLUS_SWITCH "+" /*  This switch is currently used to indicate that */
                        /*  only coils in .pos file should be printed out  */
                        /*  by -d.  It could be a multipurpose switch to   */
                        /*  augment other modes.                           */
#define MINUS_SWITCH "-"    /* Switch to indicate not to print correct coils */
#define PLUS_MINUS_SWITCH "+-" 
#define CONFIG_SWITCH "-config"


#define VER_MODE   1
#define PRN_MODE   2
#define TST_MODE0  4
#define TST_MODE1  512
#define POS_MODE   8
#define VIEW_MODE  16
#define DEBUG_MODE 32
#define PLUS_MODE 64
#define MINUS_MODE 128
#define PROLINE_FREE_MODE 256
#define MAX_WINDOW_BEFORE_COMBINE_MODE 1024
#define ABOVE_BOUND_MODE 2048   /* Only print txt file stuff above bound. */
#define NO_GUI 4096
#define WEIGHTED_PROBS 8192    /*  Uses statistical signif in computing */
                               /*  residue prob. from tables.           */
#define RAW_OUT 16384          /*  Outputs raw scores instead of likes for */
                               /*  multicoil. **/
#define USE_LIKE_LINE   32768  /* For PairCoil, if use like line or do the */
                               /* actual probability formula.              */
#define POS_STYLE_LOG 65536 /* If 0 will use singles in trimer scorer */
#define ONLY_COILED_CLASSES 131072 /* If in this mode then multicoil      */
                      /*  like will be like[class]/total_pos[like] (i.e.  */
                      /*  for class dimer it will be the prob a coil is   */
                      /*  dimer vs.  trimer. */
#define PAIRCOIL_PAIRS 262144     /* Determines if do PairCoil or SingleCoil */
                                  /* Should fix to 1 if not in TEST_VERSION */
#define LIB_AT_COMMAND_LINE 524288
#define WEB_OUT_MODE 1048576

#endif   /* __switches_h__ */
































